<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!--<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">-->

<!--
/*********************************************************** {COPYRIGHT-TOP} ***
* Licensed materials - Property of IBM
* Tivoli Presentation Services
*
* (C) Copyright IBM Corp. 2003
*
* US Government Users Restricted Rights - Use, duplication, or
* disclosure restricted by GSA ADP Schedule Contract with
* IBM Corp.
*
* Module History:
*     11/10/2005   JMiller        prevent drag-and-drop actions within the page 
************************************************************ {COPYRIGHT-END} ****/
-->
<%@taglib prefix="wcl" uri="/WEB-INF/WCLTagLib.tld"%>
<%@taglib prefix="hmc" uri="/WEB-INF/hmc.tld"%>
<%@taglib prefix="c" uri="http://java.sun.com/jstl/core"%>
<%@taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt"%>

<fmt:bundle basename="com.ibm.hwmca.ui.bonsai.res.text">

<%@page contentType="text/html;charset=UTF-8" 
		language="java"
		import="com.ibm.hwmca.ui.bonsai.status.*,
                com.ibm.hwmca.ui.bonsai.servlet.*,
                com.ibm.hwmca.ui.bonsai.servlet.util.*,
                com.ibm.hwmca.ui.bonsai.earth.*,
                com.ibm.hwmca.ui.bonsai.util.*,
                com.ibm.hwmca.fw.servlet.util.*,
                com.ibm.hwmca.fw.util.*,
                java.util.*" %>

<%!
    private static final LocalizableText TITLE = new LocalizableText("com/ibm/hwmca/ui/bonsai/res/text",
                                                                     "status.overview.title");
%>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<!-- ===========================================================================
  This JSP is a view.  That is, the WclFacade and all data is defined inside a
  controller Servlet.
  ========================================================================== -->
<wcl:Foundation
	objectScope="session"
    wclFacadeScope="<%= HMCSession.getHMCSession(session).getHMCCustomScope().getScopeName() %>"
    wclFacadeScopeId="<%= ControllerServlet.FACADE_ID_ATTRIBUTE %>"
    pageName="statusoverviewpage">

<head>

<meta http-equiv="Content-Type" content="text/html;CHARSET=UTF-8"/>

<link href="/css/ui/bonsai/statusoverview.css" rel="stylesheet" type="text/css"/>

<script src="/js/ui/bonsai/nodrag.js" type="text/javascript"></script>

<%
    // attach the user context to this thread
    ServletRuntime.getRuntime().attachUserContextToServletThread(request);

    // get the user's session data
    HMCSession hmcSession = HMCSession.getHMCSession(session);
    UserObject userObj = UserObject.getUserObject(hmcSession);

    // get the model, creating it if this is the first request by the session
    synchronized(session)
    {
        if (hmcSession.getSessionAttribute("StatusOverviewModel") == null)
        {
            StatusOverviewModel model = new StatusOverviewModel(ControllerServlet.HEALTH_TREE_KEY,
                                                                "statusoverview",
                                                                userObj);
            BonsaiTreeManager.getBonsaiTreeManager().getEventQueue().addEventQueueListener(model);
            model.init();
            hmcSession.setSessionAttribute("StatusOverviewModel", model);

            // setup a UserObjectDeathListener so we can deregister backend listener registrations
            userObj.addUserObjectDeathListener(
                new UserObjectDeathListener()
                {
                    public void userObjectDying(UserObject userObj)
                    {
                        StatusOverviewModel model = (StatusOverviewModel)(userObj.getHMCSession().getSessionAttribute("StatusOverviewModel"));
                        BonsaiTreeManager.getBonsaiTreeManager().getEventQueue().removeEventQueueListener(model);
                    }
                }
            );
        }
    }
%>

</head>

<body>

<wcl:WTitledLayout objectScopeId="statusOverviewTitle" description="To view details of exceptions and messages, click on the associated hyperlinks." title="<%= TITLE.toString(request.getLocale()) %>" ></wcl:WTitledLayout>

<div class="monitor_table">

<%
    StatusOverviewModel model = (StatusOverviewModel)(HMCSession.getHMCSession(session).getSessionAttribute("StatusOverviewModel"));
    List beans = model.getBeans();
    TypedChildrenStatisticsBean bean = null;
    Map statsMap = null;
    String className = null;
    Integer numOfType = null;
    for (Iterator i = beans.iterator(); i.hasNext(); )
    {
        bean = (TypedChildrenStatisticsBean)i.next();
%>
    <div class="<%= (bean.getTotalChildren() == 0) ? "monitor_entry_ok" : ((bean.getStatusType() == StatusUtils.STATUS_TYPE_HWMESSAGES) ?  "monitor_entry_hwmessages" : ((bean.getStatusType() == StatusUtils.STATUS_TYPE_OSMESSAGES) ? "monitor_entry_osmessages" : "monitor_entry_unacceptable")) %>">

        <div class="monitor_title_area">
            <img src="<%= bean.getImage() %>"/>
<%      if (bean.getTotalChildren() > 0) {%>
            <span class="monitor_title_text"><a class="monitor_title_text" href="<%= HealthAction.getSelectionUrl(bean.getId()) %>" target="<%= HealthAction.FRAME_NAME %>" title="<%= new LocalizableText("com/ibm/hwmca/ui/bonsai/res/text", "view.open.alt", new String[] { bean.getName() }).toString(request.getLocale()) %>"><%= bean.getName() %></a> (<%= bean.getTotalChildren() %>)</span>
<%      } else {%>
            <span class="monitor_title_text" title="<%= bean.getName() %>"><%= bean.getName() %> (0)</span>
<%      }%>
        </div>
<%
        if (bean.getTotalChildren() > 0)
        {
%>
        <div class="monitor_details_area">
<%
            statsMap = bean.getTypedChildrenStats();
            for (Iterator j = statsMap.keySet().iterator(); j.hasNext(); )
            {
                className = (String)j.next();
                numOfType = (Integer)statsMap.get(className);
                if (numOfType.intValue() > 0)
                {
%>
            <p class="monitor_details_text">
                <img height="16" width="16" src="<%= StatusUtils.getCategoryIcon(className) %>"/>
                <%= StatusUtils.getCategoryName(request.getLocale(), className) %>: <%= numOfType %>
            </p>
<%
                }
            }
%>
        </div>
<%
        }
%>
        <br style="clear: both"/>

    </div>

<%
        if (i.hasNext())
        {
%>
    <div class="monitor_entry_spacer"></div>
<%
        }
    }
%>

</div>

</body>

</wcl:Foundation>

</html>

</fmt:bundle>
